﻿Imports OpenPop.Pop3
Imports OpenPop.Mime
Imports System.Linq

Partial Class VB
    Inherits System.Web.UI.Page
    Protected Property Emails() As List(Of Email)
        Get
            Return DirectCast(ViewState("Emails"), List(Of Email))
        End Get
        Set(value As List(Of Email))
            ViewState("Emails") = value
        End Set
    End Property

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not IsPostBack Then
            Me.Read_Emails()
        End If
    End Sub

    Private Sub Read_Emails()
        Dim pop3Client As Pop3Client
        If Session("Pop3Client") Is Nothing Then
            pop3Client = New Pop3Client()
            pop3Client.Connect("pop.gmail.com", 995, True)
            pop3Client.Authenticate("youremail@gmail.com", "password", AuthenticationMethod.TryBoth)
            Session("Pop3Client") = pop3Client
        Else
            pop3Client = DirectCast(Session("Pop3Client"), Pop3Client)
        End If
        Dim count As Integer = pop3Client.GetMessageCount()
        Me.Emails = New List(Of Email)()
        Dim counter As Integer = 0
        For i As Integer = count To 1 Step -1
            Dim message As Message = pop3Client.GetMessage(i)
            Dim email As New Email()
            email.MessageNumber = i
            email.Subject = message.Headers.Subject
            email.DateSent = message.Headers.DateSent
            email.From = String.Format("<a href = 'mailto:{1}'>{0}</a>", message.Headers.From.DisplayName, message.Headers.From.Address)

            Dim body As MessagePart = message.FindFirstHtmlVersion()
            If body IsNot Nothing Then
                email.Body = body.GetBodyAsText()
            Else
                body = message.FindFirstPlainTextVersion()
                If body IsNot Nothing Then
                    email.Body = body.GetBodyAsText()
                End If
            End If
            Dim attachments As List(Of MessagePart) = message.FindAllAttachments()

            For Each attachment As MessagePart In attachments
                Dim attachmentObj As New Attachment
                attachmentObj.FileName = attachment.FileName
                attachmentObj.ContentType = attachment.ContentType.MediaType
                attachmentObj.Content = attachment.Body
                email.Attachments.Add(attachmentObj)
            Next
            Me.Emails.Add(email)
            counter += 1
            If counter > 2 Then
                Exit For
            End If
        Next
        gvEmails.DataSource = Me.Emails
        gvEmails.DataBind()
    End Sub
    Protected Sub OnRowDataBound(sender As Object, e As GridViewRowEventArgs)
        If e.Row.RowType = DataControlRowType.DataRow Then
            Dim rptAttachments As Repeater = TryCast(e.Row.FindControl("rptAttachments"), Repeater)
            Dim attachments As List(Of Attachment) = Me.Emails.Where(Function(email) email.MessageNumber = Convert.ToInt32(gvEmails.DataKeys(e.Row.RowIndex).Value)).FirstOrDefault().Attachments
            rptAttachments.DataSource = attachments
            rptAttachments.DataBind()
        End If
    End Sub
    Protected Sub Download(sender As Object, e As EventArgs)
        Dim lnkAttachment As LinkButton = TryCast(sender, LinkButton)
        Dim row As GridViewRow = TryCast(lnkAttachment.Parent.Parent.NamingContainer, GridViewRow)
        Dim attachments As List(Of Attachment) = Me.Emails.Where(Function(email) email.MessageNumber = Convert.ToInt32(gvEmails.DataKeys(row.RowIndex).Value)).FirstOrDefault().Attachments
        Dim attachment As Attachment = attachments.Where(Function(a) a.FileName = lnkAttachment.Text).FirstOrDefault()
        Response.AddHeader("content-disposition", "attachment;filename=" + attachment.FileName)
        Response.ContentType = attachment.ContentType
        Response.BinaryWrite(attachment.Content)
        Response.End()
    End Sub

End Class


<Serializable()> _
Public Class Email
    Public Sub New()
        Me.Attachments = New List(Of Attachment)()
    End Sub
    Public Property MessageNumber() As Integer
        Get
            Return m_MessageNumber
        End Get
        Set(value As Integer)
            m_MessageNumber = Value
        End Set
    End Property
    Private m_MessageNumber As Integer
    Public Property From() As String
        Get
            Return m_From
        End Get
        Set(value As String)
            m_From = Value
        End Set
    End Property
    Private m_From As String
    Public Property Subject() As String
        Get
            Return m_Subject
        End Get
        Set(value As String)
            m_Subject = Value
        End Set
    End Property
    Private m_Subject As String
    Public Property Body() As String
        Get
            Return m_Body
        End Get
        Set(value As String)
            m_Body = Value
        End Set
    End Property
    Private m_Body As String
    Public Property DateSent() As DateTime
        Get
            Return m_DateSent
        End Get
        Set(value As DateTime)
            m_DateSent = Value
        End Set
    End Property
    Private m_DateSent As DateTime
    Public Property Attachments() As List(Of Attachment)
        Get
            Return m_Attachments
        End Get
        Set(value As List(Of Attachment))
            m_Attachments = Value
        End Set
    End Property
    Private m_Attachments As List(Of Attachment)
End Class

<Serializable()> _
Public Class Attachment
    Public Property FileName() As String
        Get
            Return m_FileName
        End Get
        Set(value As String)
            m_FileName = Value
        End Set
    End Property
    Private m_FileName As String
    Public Property ContentType() As String
        Get
            Return m_ContentType
        End Get
        Set(value As String)
            m_ContentType = Value
        End Set
    End Property
    Private m_ContentType As String
    Public Property Content() As Byte()
        Get
            Return m_Content
        End Get
        Set(value As Byte())
            m_Content = Value
        End Set
    End Property
    Private m_Content As Byte()
End Class
